=== debian/changelog ===
linphone-desktop (5.2.6+dfsg-1build1) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Mon, 14 Jul 2025 14:26:49 +0300

linphone-desktop (5.2.6+dfsg-1) unstable; urgency=high

  * Team upload
  * Repack upstream
  * New upstream version 5.2.6 (Closes: #1100237)
  * Disable SpellChecker
  * Use system's singleapplication
  * Disable QtKeychain support

 -- Bastian Germann <bage@debian.org>  Wed, 09 Apr 2025 13:15:14 +0200

linphone-desktop (5.1.2-2) experimental; urgency=medium

  * shlib-collision-watchdog: add more helpful details on error.

 -- Dennis Filder <d.filder@web.de>  Thu, 05 Oct 2023 22:17:12 +0200

linphone-desktop (5.1.2-1) experimental; urgency=medium

  * New upstream release 5.1.2.
  * New build dependencies on qt5keychain-dev and qtmultimedia5-dev.
  * Add shlib-collision-watchdog to break the build when accidentally
    linking different version of the same shared library.

 -- Dennis Filder <d.filder@web.de>  Mon, 04 Sep 2023 10:27:13 +0200
